/* ShaderObject: GL_VERTEX_SHADER */
#version 330
uniform mat4 uModelViewProjMat;
layout(location = 0) in vec3 inPos;
layout(location = 1) in vec2 inTexCoord;
out vec2 vTexCoord;
 
void main(void)
{
  gl_Position = vec4(inPos, 1.0);
  vTexCoord   = inTexCoord;
}

/* ShaderObject: GL_FRAGMENT_SHADER */
#version 330
uniform sampler2D uTexture;
in vec2 vTexCoord;
out vec4 outColor;
 
void main(void)
{
  outColor = texture(uTexture, vTexCoord);
}